Rotate Image - Matrix - Leetcode 48

แชร์
ฝัง
  • เผยแพร่เมื่อ 21 ก.ค. 2024
  • 🚀 neetcode.io/ - A better way to prepare for Coding Interviews
    🐦 Twitter: / neetcode1
    🥷 Discord: / discord
    🐮 Support the channel: / neetcode
    Twitter: / neetcode1
    Discord: / discord
    💡 CODING SOLUTIONS: • Coding Interview Solut...
    💡 DYNAMIC PROGRAMMING PLAYLIST: • House Robber - Leetco...
    🌲 TREE PLAYLIST: • Invert Binary Tree - D...
    💡 GRAPH PLAYLIST: • Course Schedule - Grap...
    💡 BACKTRACKING PLAYLIST: • Word Search - Backtrac...
    💡 LINKED LIST PLAYLIST: • Reverse Linked List - ...
    Problem Link: neetcode.io/problems/rotate-m...
    0:00 - Read the problem
    3:25 - Drawing explanation
    9:55 - Coding explanation
    leetcode 48
    This question was identified as a microsoft interview question from here: github.com/xizhengszhang/Leet...
    #microsoft #matrix #python
    Disclosure: Some of the links above may be affiliate links, from which I may earn a small commission.
  • วิทยาศาสตร์และเทคโนโลยี

ความคิดเห็น • 284

  • @NeetCode
    @NeetCode  2 ปีที่แล้ว +15

    🚀 neetcode.io/ - A better way to prepare for Coding Interviews

  • @meowmaple
    @meowmaple 2 ปีที่แล้ว +223

    This is a clear explanation, but definitely still not the simplest. For me, the most straightforward method is to transpose the matrix and reverse each row.
    The code is simple and short.
    #transpose
    for row in range(len(matrix)):
    for col in range(row,len(matrix)):
    temp = matrix[row][col]
    matrix[row][col] = matrix[col][row]
    matrix[col][row] = temp
    #reverse
    for row in matrix:
    row.reverse()
    Accepted by leetcode.

    • @almasmirzakhmetov8590
      @almasmirzakhmetov8590 2 ปีที่แล้ว +4

      excellent solution. By the way your solution is based on rotation matrix, right?
      For 90 degree, we have (x,y) -> (y,x)
      en.wikipedia.org/wiki/Rotation_matrix

    • @Rahul-pr1zr
      @Rahul-pr1zr 2 ปีที่แล้ว +27

      How do you even get the idea to transpose and then reverse? I agree that implementation is easier but the idea doesn't seem that simple.

    • @333jjjjjj
      @333jjjjjj 2 ปีที่แล้ว +35

      @@Rahul-pr1zr You need to recall it from your linear algebra class. Good luck if that was more than a few months ago or never.

    • @peterpace3379
      @peterpace3379 2 ปีที่แล้ว

      @@333jjjjjj for me it was a whole year ago lmao

    • @przemysawpobrotyn1195
      @przemysawpobrotyn1195 2 ปีที่แล้ว +3

      I have another solution in similar vein. I came up with it by eyeballing the leetcode provided input/output samples and noticing that the firs element of the last row of the input is the first element of the first row of the output, the second element of the last row of the input is the first element of the second row of the output etc. thus
      n = len(matrix)
      for row in matrix[::-1]:
      for i in range(n):
      element = row.pop(0)
      matrix[i].append(element)
      also does the job ;)

  • @srinadhp
    @srinadhp 2 ปีที่แล้ว +200

    This has been one of the toughest problems for me. Very hard to visualize and always used to make mistakes even after multiple attempts. The way that you explained the approach is THE BEST. You made it so crystal clear in visualizing the solution. Thank you so much!

    • @sidkapoor9085
      @sidkapoor9085 2 ปีที่แล้ว +8

      I found it way easier, almost trivial when I stopped looking at the "2D matrix" and just at the input and output lists.

    • @caniaccombo123
      @caniaccombo123 2 ปีที่แล้ว +2

      @@sidkapoor9085 mind blown

    • @markomekjavic
      @markomekjavic 2 ปีที่แล้ว +8

      I honestly think this is a Hard problem when it comes to implementation.. you can see the idea but coming up with the double pointer approach and a loop, thats a different story!

    • @huansir1922
      @huansir1922 ปีที่แล้ว

      @@markomekjavic yes,coming up with the double pointer approach , it seems hard

    • @princeanthony8525
      @princeanthony8525 ปีที่แล้ว

      Same here.

  • @doublegdog
    @doublegdog 2 ปีที่แล้ว +152

    Just got an offer at amazon. Your videos rock and helped me out so much!

    • @NeetCode
      @NeetCode  2 ปีที่แล้ว +19

      Congratulations 🎉

  • @xqfang3171
    @xqfang3171 2 ปีที่แล้ว +13

    This is the best explanation for this problem. Crystal clear visualization, elegant code. Great job. Thank you so much for posting!

    • @NeetCode
      @NeetCode  2 ปีที่แล้ว +1

      Happy it was helpful! :)

  • @MsSkip60
    @MsSkip60 3 ปีที่แล้ว +107

    Thanks a lot for the content mate! No offence to others but I really like your clear accent and structured material which is easy to follow. Hope you keep up posting!

  • @ishaanjain4973
    @ishaanjain4973 ปีที่แล้ว

    I cant explain you how much this channel helps me !! Other channels just tell the transpose method which is not so intuitive, you always tell solutions which I can think in future in real interviews and exams. Thanks a lot Neetcode !! Keep up the good work man

  • @d1rtyharry378
    @d1rtyharry378 2 ปีที่แล้ว +28

    Bro what an structured approach . Really loved your way of teaching man! You made it look so easy.

    • @NeetCode
      @NeetCode  2 ปีที่แล้ว +7

      Thanks!

  • @annieonee
    @annieonee 2 ปีที่แล้ว +3

    This is the best explanation of this problem so I've found. Thank you so much for the content! Keep up the good work 👏

  • @lottexy
    @lottexy 2 ปีที่แล้ว +12

    I gotta say your videos are amazing. I've been grinding LC for the past 3 weeks, I went from struggling to solve even 1 question on the weekly leetcode contest to solving 2 - 3 questions each week. Thank you so much. I've also and will always share your videos and excel sheet on reddit whenever people ask for leetcode tips. Oh and its abit late but congrats on the Google offer!
    I hope to one day get into google as well or any other company tbh ( my current tech job kinda blows ) ...

    • @suraj8092
      @suraj8092 2 ปีที่แล้ว +4

      Good luck!

  • @sumosam1980
    @sumosam1980 3 ปีที่แล้ว +1

    Your videos are excellent. You do a great job of being super clear! I often come here to Neetcode to see if you have the solution as it is better than the official explanation. Keep up the great work!

  • @emanawel9224
    @emanawel9224 2 ปีที่แล้ว +2

    This code makes the problem look way easier than it is! Love the code and explanation.

  • @sureshgarine
    @sureshgarine 2 ปีที่แล้ว +1

    I really like the way u handled minimizing the temp variable swap. very well explained. Thank you so much.

  • @jananiadanurrammohan9795
    @jananiadanurrammohan9795 2 ปีที่แล้ว +2

    Best explanation one could ever give for a problem!!!. Thank you for the effort and time you are putting into making all these videos.

  • @mykytapiskarov7291
    @mykytapiskarov7291 2 ปีที่แล้ว

    Amazing solution and explanaition! I spent about 2 hours trying to understand leetcode "Rotate group of 4" solution - but no luck. Here 15 minutes - and it's clear.

  • @himanshubansal7040
    @himanshubansal7040 ปีที่แล้ว

    This is a beautiful way to write the code for this tricky problem. Kudos!!

  • @suhasdon1
    @suhasdon1 3 ปีที่แล้ว +4

    Thank you. Best explanation without having to deal with 2 for loops with i, j or recursion and all other BS to be worried about.

  • @codewithtejesh1284
    @codewithtejesh1284 2 ปีที่แล้ว +1

    thanks a lot, great explanation!
    i stopped my leetcode subscription , now i am just watching your videos and solving question.

  • @sanidhyax
    @sanidhyax 23 วันที่ผ่านมา

    This is so elegant. Have solved multiple of 2d array problems but never thought of accessing the rows literally by [bottom[[R] and [top][L]

  • @parthpatel8532
    @parthpatel8532 2 ปีที่แล้ว +13

    Although this is a good way to do it, I found my way to be a bit simpler once you understand matrix manipulation. Rotating a matrix by 90⁰ is equivalent to flipping the matrix diagonally and then flipping it vertically. First try it out with paper, and once u get it, it's really easy. It doesn't save runtime or anything, but I find it easier in terms of code than to move 4 things at a time layer by layer.

    • @jim5621
      @jim5621 ปีที่แล้ว +1

      Brilliant idea. But this solution takes 2x time since you need to loop through the matrix twice.
      But the time complexity is still O(n) though. Good thinking!

    • @brainmaxxing1
      @brainmaxxing1 10 หลายเดือนก่อน +1

      ​@@jim5621 "This solution takes 2x time" isn't actually true. Because of things like cache locality, where the elements that are in the same row will be closer to operate on for the CPU, it's not possible to say that the element-wise method is faster.
      The profiling method actually worked about 25% faster from tests on my computer!

  • @ArunRampure
    @ArunRampure 2 วันที่ผ่านมา

    Have been struggling with coming up with an notion of using boundaries and using that i variable. Neet explanations for the neet code to write. Thanks for adding this.

  • @chichiem2397
    @chichiem2397 ปีที่แล้ว

    These videos are great, this one in particular is perfect. I struggled with this a lot until I checked out this video. Awesome stuff!

  • @nayanachandran7072
    @nayanachandran7072 2 ปีที่แล้ว

    I must've have tried to understand this problem atleast 10 times and always failing to remember it. I now know I will never forget it! Thanks!

  • @bruce716
    @bruce716 2 ปีที่แล้ว

    Thanks for the details and it is really easier to understand the concept with your good variable naming convention.

  • @seungjunlee00
    @seungjunlee00 2 ปีที่แล้ว +1

    Thank you so much for the straightforward and clear answer!

  • @jimmycheong7970
    @jimmycheong7970 2 ปีที่แล้ว +2

    This is a freaking amazing explanation. Thank you so much for sharing!

  • @ElijahGeorge
    @ElijahGeorge 2 ปีที่แล้ว +1

    This is a very intuitive explanation. Thanks so much!!

  • @bilalahmedkhan9518
    @bilalahmedkhan9518 2 ปีที่แล้ว

    I thought this was a very though problem but you made it so easy for me. Thank you!

  • @krishnateja6428
    @krishnateja6428 8 หลายเดือนก่อน

    Cleanest explanation I have ever seen. Thank you!

  • @yabgdouglas6032
    @yabgdouglas6032 11 หลายเดือนก่อน

    my ego has made me attempt this problem almost 3 hours - thank you for this clean explanation!

  • @Cruzylife
    @Cruzylife 2 ปีที่แล้ว +2

    wow this explanation was so clear and the code was so clean!!

  • @anxonpues6018
    @anxonpues6018 29 วันที่ผ่านมา

    Good, explanation, improoving steps ... really golden pedagogical

  • @alinisar87
    @alinisar87 3 ปีที่แล้ว +1

    Beautiful solution, great explanation. Thank you so much.

  • @dineshraj5957
    @dineshraj5957 11 หลายเดือนก่อน

    The best explanation by far of the layer rotation method. Damn it. The best!!

  • @nayandhabarde
    @nayandhabarde 3 ปีที่แล้ว +1

    Good work with comments and simplicity!

  • @leonfeng4006
    @leonfeng4006 2 ปีที่แล้ว

    please continue to make more videos, this channel is pure gold

  • @bondinthepond
    @bondinthepond 2 ปีที่แล้ว +1

    Amazing approach - very structured! and of course backed by great visualization!! You've got a subscriber, just based on this!! :)

  • @vaibhavkhanna2922
    @vaibhavkhanna2922 ปีที่แล้ว

    Great approach! Here you can see if you are confused with variable naming I have used some easy to understand names.Approach is still the same.
    void rotate(vector &matrix)
    {
    int size = matrix.size();
    int startRow = 0;
    int startColumn = 0;
    int endRow = matrix.size() - 1;
    int endColumn = matrix.size() - 1;
    while (startRow < endRow && startColumn < endColumn)
    {
    int current_column_for_start_row = startColumn;
    int current_row_for_end_Column = startRow;
    int current_column_for_end_row = endColumn;
    int current_row_for_start_column = endRow;
    int current_size = endColumn - startColumn;
    for (int i = 0; i < current_size; i++)
    {
    int temp = matrix[startRow][current_column_for_start_row];
    matrix[startRow][current_column_for_start_row] = matrix[current_row_for_start_column][startColumn];
    matrix[current_row_for_start_column][startColumn] = matrix[endRow][current_column_for_end_row];
    matrix[endRow][current_column_for_end_row] = matrix[current_row_for_end_Column][endColumn];
    matrix[current_row_for_end_Column][endColumn] = temp;
    current_column_for_start_row++;
    current_row_for_end_Column++;
    current_column_for_end_row--;
    current_row_for_start_column--;
    }

    startRow++;
    startColumn++;
    endRow--;
    endColumn--;
    }
    }

  • @mr.anonymous6098
    @mr.anonymous6098 2 ปีที่แล้ว +1

    Perfect Solution. When I first read the solution in the Cracking the coding interview book, I spent quite a lot of time and still could not understand it. You really simplified the logic which is so much easier to follow! Great Job, man

  • @anooppatils
    @anooppatils 2 ปีที่แล้ว

    Awesome Explanation. Just loved it. Keep up the good work :)

  • @jasonngan5747
    @jasonngan5747 2 ปีที่แล้ว

    This is super useful, thanks for the great work!

  • @symbol767
    @symbol767 2 ปีที่แล้ว +3

    This shows me how many people in the comments don't even try the solution themselves.
    I tried the solution in this video on leetcode and it doesn't pass the test cases.

    • @davidteklea1032
      @davidteklea1032 4 หลายเดือนก่อน

      I tried it, it passes.

  • @huimingli9207
    @huimingli9207 ปีที่แล้ว +1

    This is really a pure math problem. rotating a cell 90 degree, the index/coordinate change is from (x,y) -> (y, n-1-x).

  • @karthikjayaraman9646
    @karthikjayaraman9646 3 ปีที่แล้ว

    Excellent article. Keep'em coming!

  • @itspete2444
    @itspete2444 4 หลายเดือนก่อน

    "This is still a square if you tilt your head enough" - that got me laughing harder than it should have

  • @sanketkoli8641
    @sanketkoli8641 ปีที่แล้ว

    Very nice explanation. Thanks NeetCode!

  • @yasharma2301
    @yasharma2301 2 ปีที่แล้ว

    Knew the O(2*n^2) solution using transpose followed by inversion, thanks for this great one pass solution.

  • @wij8044
    @wij8044 8 หลายเดือนก่อน

    Easier solution for nXn matrix! Neetcode solution may be better suited for nXm matrix.
    function rotate(matrix: number[][]): void {
    const n = matrix.length;
    // Transpose the matrix, starting from i = 1
    for (let i = 1; i < n; i++) {
    for (let j = i; j < n; j++) {
    [matrix[i][j], matrix[j][i]] = [matrix[j][i], matrix[i][j]];
    }
    }
    // Reverse each row
    for (let i = 0; i < n; i++) {
    matrix[i].reverse();
    }
    }

  • @akifozkan5065
    @akifozkan5065 2 ปีที่แล้ว

    made it look like so simple, great explanation

  • @reaiswaryaa
    @reaiswaryaa 2 ปีที่แล้ว

    Wow what an amazing explanation. Thank you !

  • @niteshsetin
    @niteshsetin 2 ปีที่แล้ว

    The explanation was awesome and helpful to understand the problem effectively. I was waiting to see the final input output but nevertheless the code is correct so i guess i will write and check myself 😁😊

  • @nikiforovsansanich
    @nikiforovsansanich 2 ปีที่แล้ว +1

    Perfect explanation! Thank you!

  • @DanielTruongDev
    @DanielTruongDev 2 ปีที่แล้ว

    Great explanation, however if you recalled from Linear Algebra, this is basically transpose the matrix so (row,col) becomes (col,row). So here's a shorter solution in Python
    rows = len(matrix)
    matrix.reverse() #Reverse the matrix
    for r in range(rows):
    for c in range(r,rows):
    matrix[r][c], matrix[c][r] = matrix[c][r], matrix[r][c] #Transpose

  • @franly656
    @franly656 9 หลายเดือนก่อน

    hi neetcode, i have a question, how to rotate matrix 45 degrees so the matrix size will increase, i trying to make the solution and now i want to give up (i have tried straight 5 hours btw). Can you make this solution a video pls.

  • @collinskariuki2586
    @collinskariuki2586 2 ปีที่แล้ว

    Hey. Thank you for the explanation. Query: In your drawing, you portray the bottom pointer moving up and the top pointer moving down, so it's kinda confusing for me because in your code you write 'bottom - i' and 'top + i'. Mind explaining this distinction?

  • @ethanking123
    @ethanking123 8 หลายเดือนก่อน

    Could you provide a C++ solution? The C++ approach on your website appears to be a direct copy from LeetCode, which differs from the demonstration in this video

  • @TheMzbac
    @TheMzbac 2 ปีที่แล้ว

    Very clearly explained, thank you

  • @dollyvishwakarma2
    @dollyvishwakarma2 2 ปีที่แล้ว +2

    No doubt I love your simple algos but this one can be done in a much simpler way which is to reverse the matrix row wise and then swapping the elements like we do for a transpose.
    Kudos to the great work you do :)

    • @user-xg2wj4dy5f
      @user-xg2wj4dy5f ปีที่แล้ว +3

      But to do that you will have to create another matrix which is the copy of the Matrix which is to be transposed and that is against the constraints of the question you have to work in the same Matrix

  • @harishdukkipati8921
    @harishdukkipati8921 ปีที่แล้ว

    Your explanation is very clear and I understand how it works. However, when I try it on leetcode it says my time limit is exceeded. Would you have any reason for why that would be the case.

  • @ChocolateMilkCultLeader
    @ChocolateMilkCultLeader 2 ปีที่แล้ว

    Your code was really elegant. Well done

  • @FreeMayaTutorials
    @FreeMayaTutorials 3 ปีที่แล้ว +1

    Thanks for posting, this is great!

  • @kwaminaessuahmensah8920
    @kwaminaessuahmensah8920 2 ปีที่แล้ว +2

    Mans went into god mode swapping the elements in reverse

  • @ShivangiSingh-wc3gk
    @ShivangiSingh-wc3gk 2 ปีที่แล้ว

    Nice, explanation. I thought the same thing but got thrown off on how to get the indexes

  • @aaronpuah918
    @aaronpuah918 2 ปีที่แล้ว

    You really are the Bob Ross of LeetCode XD

  • @harishsn4866
    @harishsn4866 ปีที่แล้ว

    Thank you so much. You're the best.

  • @suvrobanerjee2399
    @suvrobanerjee2399 ปีที่แล้ว

    Thanks for such a clear explanation.

  • @rahulsreedharan1922
    @rahulsreedharan1922 2 ปีที่แล้ว

    Great video. Just one question - why are the elements replaced in a counterclockwise manner? What benefit does it have over the more intuitive way of just replacing it clockwise?

  • @KarthikChintalaOfficial
    @KarthikChintalaOfficial หลายเดือนก่อน

    Like the approach. But it's tedious to really remember and do it. I like the transposing and reversing using a 2 ptr approach to do this.

  • @Michael-zh3op
    @Michael-zh3op 24 วันที่ผ่านมา

    After playing around with matrices, this question was a cake walk.

  • @MinhNguyen-lz1pg
    @MinhNguyen-lz1pg ปีที่แล้ว

    Another great explanation my dude !

  • @algorithmimplementer415
    @algorithmimplementer415 2 ปีที่แล้ว

    This is the best explanation!!

  • @hunglam2680
    @hunglam2680 2 ปีที่แล้ว

    thank you. this problem has been bugging me, i figured out how to rotate the image but couldn't implement it properly.

  • @sunnyding602
    @sunnyding602 ปีที่แล้ว

    Thanks for the clear explanation. I can understand it while I am in a food coma. lol

  • @pengmick2046
    @pengmick2046 ปีที่แล้ว

    Your explanation is so good

  • @burburchacha
    @burburchacha 7 หลายเดือนก่อน

    I hope you realise that you have a gift in explaining difficult concepts

  • @josecarlosfontanesikling306
    @josecarlosfontanesikling306 ปีที่แล้ว

    It's possible to do this without any extra memory at all.
    Suppose you have variables x and y. You can swap them like this
    y=y+x
    x=y-x
    y=y-x
    This is all you need to transpose a matrix and to swap columns or rows. This rotation is just a transposition followed by inverting the order of the rows.

  • @RandomShowerThoughts
    @RandomShowerThoughts ปีที่แล้ว

    very intuitive

  • @eugenesol2074
    @eugenesol2074 2 หลายเดือนก่อน

    Nice, thanks for that

  • @ledinhanhtan
    @ledinhanhtan ปีที่แล้ว

    Beautiful code~

  • @navenkumarduraisamy6260
    @navenkumarduraisamy6260 3 ปีที่แล้ว +1

    I really wish I had such clear approach

  • @stith_pragya
    @stith_pragya ปีที่แล้ว

    Thank You Brother for this amazing video.............🙏🙏🙏🙏🙏🙏

  • @AshishSarin1
    @AshishSarin1 2 ปีที่แล้ว

    Thanks for this explanation. Really liked it.

    • @NeetCode
      @NeetCode  2 ปีที่แล้ว +1

      Thank you so much!! Glad it was helpful!

  • @nilkamalthakuria4030
    @nilkamalthakuria4030 3 ปีที่แล้ว +1

    Great explanation

  • @suchitranagarajan7715
    @suchitranagarajan7715 2 ปีที่แล้ว

    Great explanation!!!

  • @cse_33_ayandutta48
    @cse_33_ayandutta48 ปีที่แล้ว

    Does it works for rectangle also?

  • @Blobtheblobfish
    @Blobtheblobfish 3 ปีที่แล้ว +3

    Here is a js solution
    const rotate = (matrix) => {
    let left = 0;
    // number of columns - 1,
    // also think, actual position of right
    let right = matrix.length - 1;

    while (left < right) {
    for (let i = 0; i < right - left; i++) {
    let top = left;
    let bottom = right;

    let topLeft = matrix[top][left + i];

    matrix[top][left + i] = matrix[bottom - i][left];

    matrix[bottom - i][left] = matrix[bottom][right - i];

    matrix[bottom][right - i] = matrix[top + i][right];

    matrix[top + i][right] = topLeft;

    }
    left++;
    right--;
    }
    };
    yes I know, py and JS are about as close to languages as you can get but for anyone new or may not understand the small differences between py and JS, here is your answer. NeetCode, thank you, your explanation was thorough and also less than 15 minutes which is great.

  • @PavelBogart
    @PavelBogart 2 ปีที่แล้ว

    love it. thank you!

  • @ashinshenoy84
    @ashinshenoy84 2 ปีที่แล้ว

    Very well explained, but i spotted one line which could be shifted up.
    Line 10 can be put before the for loop isnt it ? no need to initialize it on every loop

  • @siddharthgupta6162
    @siddharthgupta6162 2 ปีที่แล้ว

    This video is so so so (X100) much better than the leetcode's solutions on this problem.

  • @Nick-qy7lk
    @Nick-qy7lk ปีที่แล้ว

    Hi guys, does anyone know why the for loop (line 9) has to be range(right - left)? I thought range(left, right - 1) would work but I've tried it and it doesn't on the harder test cases. I can't wrap my head around why. Would appreciate any help.

    • @brainmaxxing1
      @brainmaxxing1 10 หลายเดือนก่อน

      The problem is that the indexing "breaks down" once 'left' gets increased. For the sample test cases, the size is smaller, like 3x3 or 4x4, and it passes there.
      If you're doing range(left, right - 1) that makes i = left, left + 1, left + 2 instead of 0, 1, 2.
      It means you'd need to change your calls like matrix[top][left+i] should instead be matrix[top][i] and the calls like matrix[bottom-i][left] should instead be matrix[bottom-i+left][left].
      The full code:
      class Solution:
      def rotate(self, matrix: List[List[int]]) -> None:
      """
      Do not return anything, modify matrix in-place instead.
      """
      n = len(matrix)
      left, right = 0, n - 1
      while left

  • @nikhilgoyal007
    @nikhilgoyal007 ปีที่แล้ว

    how does leetcode verify solutions to problems where there is no return value but just in place change? thank you!

    • @brainmaxxing1
      @brainmaxxing1 10 หลายเดือนก่อน

      What you pass into the function, the argument 'matrix' is actually a reference to the matrix, so when the function changes the matrix, your matrix changes as well.
      Like this
      colab.research.google.com/drive/1laaMa1XLalAsShcoqENbbD5peb-PdCHo?usp=sharing

  • @SarveshBhatnagar1214
    @SarveshBhatnagar1214 2 ปีที่แล้ว

    I found more two approaches to this, First one is to reverse the image and then transpose the resulting matrix (Easier). Other approach is to do this matrix[:] = zip(*matrix[::-1]) I don't really understand what's happening here so if someone understands, please do tell :) Thanks!

  • @Omar-hw7zi
    @Omar-hw7zi 3 ปีที่แล้ว +1

    WOW, really neat!!

  • @pleasedontsubscribeme4397
    @pleasedontsubscribeme4397 2 ปีที่แล้ว

    Best of the best solution!

  • @zr60
    @zr60 2 ปีที่แล้ว

    Chances are , you will not be able to think of a solution such as the second one (the one that stores only 1 variable). It's better to practise for the solution for the first one (the one that stores 4 different variables).

  • @eltaylor778
    @eltaylor778 ปีที่แล้ว +1

    Great explanation, does anyone know why the range has to be range(right- left) instead of range(left,right)? The range(left,right) works on many of the smaller test cases but does not work on many of the harder ones. Help!

    • @kritmok1875
      @kritmok1875 9 หลายเดือนก่อน

      that's because we always want to start the i with 0.
      let's take (2, 4) as an example
      range(2,4) return 2,3
      but range(4-2) return 0, 1

  • @dr.merlot1532
    @dr.merlot1532 2 ปีที่แล้ว

    The guys talking about transpose mean this: Geometrically, rotation of the plane by 90 degrees is equivalent to flipping about the diagonal line y=-x and then flipping about the y-axis. That's why this works.

  • @prankobano9076
    @prankobano9076 ปีที่แล้ว

    Cool beans dude!

  • @akshatsharma7639
    @akshatsharma7639 2 ปีที่แล้ว

    why we cannot take "for i in range(l,r) "instead of "for i in range(l-r)"?

  • @Tensor08
    @Tensor08 2 ปีที่แล้ว +5

    I did this in one line 😎 which beats 97%
    matrix[:] = list(zip(*matrix[::-1]))